/*
IXAttributeQuery.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	<objc/Object.h>
#import	<objc/hashtable.h>

@class IXAttributeParser;
@class IXPostingList;

@interface IXAttributeQuery: Object
{
    NXZone		*_queryZone;
    id			_queryBinder;
    BOOL		_freeBinder;
    NXHashTable		*_objectTable;
    NXHashTable		*_opaqueTable;
    NXHashTable		*_namingTable;
    struct TermRecord	*_queryParse;
    struct TermRecord	*_queryStack;
    id			attributeParser;
    id			queryContext;
    unsigned char	*queryString;
}

- initQueryString:(const char *)string 
    andAttributeParser:(IXAttributeParser *)aParser;

#ifdef	KANJI
- initQueryString:(const char *)string 
    andAttributeParser:(IXAttributeParser *)aParser forContext:anObject;
#endif	KANJI

- (char *)attributeNames;
- (IXAttributeParser *)attributeParser;
- (const char *)queryString;

- (IXPostingList *)evaluateFor:anObject;

@end

