/*
IXFileRecord.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	<objc/Object.h>
#import	<remote/transport.h>

@class IXFileFinder;

@interface IXFileRecord: Object <NXTransport>
{
    id			_bindings;
@public
    unsigned		filedate;
    IXFileFinder	*fileFinder;
    char		*filename;
    char		*filetype;
    char		*description;
    struct stat		*statBuffer;
}

- (IXFileFinder *)fileFinder;
- initWithFileFinder:(IXFileFinder *)aFinder;

- (const struct stat *)statBuffer; // stats file if necessary

- (const char *)filename; // returns the recorded file name
- setFilename:(const char *)name; // sets the recorded file name

- (const char *)filetype; // returns the recorded file type 
- setFiletype:(const char *)type; // sets drecorded file type

- (const char *)description; // returns the recorded description 
- setDescription:(const char *)aDescription; // sets the recorded description

- (unsigned)filedate; // returns the recorded modification date
- setFiledate:(unsigned)date; // sets the recorded modification date

@end

