/*
IXRecordManager.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	"IXAttributeParser.h"
#import	"IXPostingList.h"
#import	<btree/IXPostingCursor.h>
#import	<mach/cthreads.h>

@class IXStore, IXBTreeCursor;

extern IXAttributeParser *IXDefaultAttributeParser();

@interface IXRecordManager: Object 
<IXBlockAndStoreAccess, IXNameAndFileAccess, IXRecordWriting, IXRecordDiscarding, IXBlobWriting, IXTransientAccess, IXTransientMessaging>
{
    struct mutex		_mutexLock;
    id				_storeDirectory;
    id				_dataRepository;
    BOOL			_freeStorage;
    unsigned			_blockHandle;
    char			*_handleName;
    IXStore			*_storageManager;
    struct _NXMapTable		*_attributeNames;
    struct _NXMapTable		*_attributeLists;
    struct _NXMapTable		*_privateCursors;
    IXBTreeCursor		*_attributeBTree;
}

- removeAttributeNamed:(const char *)name;
- addAttributeNamed:(const char *)name forSelector:(SEL)selector;
- (BOOL)hasAttributeNamed:(const char *)name;

- (char *)attributeNames;
- (IXPostingCursor *)cursorForAttributeNamed:(const char *)name;
- (SEL)selectorForAttributeNamed:(const char *)name;

- (char *)classNames;
- (char *)attributeNamesForClass:aClass;

- (IXPostingList *)discards;
- (IXPostingList *)recordsForClass:aClass;

- setTargetClass:aClass forAttributeNamed:(const char *)name;
- getTargetName:(const char **)target andVersion:(unsigned *)version 
    forAttributeNamed:(const char *)name;

- getDescription:(char **)aDescription 
    forAttributeNamed:(const char *)name;
- setDescription:(const char *)aDescription 
    forAttributeNamed:(const char *)name;

- (const char *)comparisonFormatForAttributeNamed:(const char *)name;
- setComparisonFormat:(const char *)aFormat 
    forAttributeNamed:(const char *)name;

- getComparator:(IXComparator **)comparator andContext:(const void **)context 
    forAttributeNamed:(const char *)name;
- setComparator:(IXComparator *)comparator andContext:(const void *)context 
    forhibuteNamed:(const char *)name;

- (IXAttributeParser *)parserForAttributeNamed:(const char *)name;
- setParser:(IXAttributeParser *)aParser 
    forAttributeNamed:(const char *)name;

@end

