/*
 *	ISDN/POTS Project
 *	Copyright 1991, NeXT, Inc.
 * 
 *	NXPhoneChannel.h (Client side)
 *
 *	Interface declaration for NXPhoneChannel object.
 *
 *	NXPhoneChannel objects and their subclasses are used to facilitate
 *	communication between the POTS/ISDN server anF's clients.
 *
 *	A NXPhoneChannel object is the bearer of one or more virtual calls.
 *	Each virtual call is represented by a NXPhoneCall object. 
 */
#import <objc/Object.h>
#import "NXPhoneCall.h"
#import "phoneTypes.h"


@interface NXPhoneChannel : Object
{
    void *_private;
}

- init;
- initType: (NXPhoneChannelType)chan;

@end

/*
 *   These methods are forwarded to the phone server.
 */
@interface NXPhoneChannel (RemoteMethods)
  
   
/*
 *   Call management
 */
- (void)setType: (NXPhoneChannelType)c;
- (NXPhoneChannelType)type;		
- (void) addCall: call;
- (void) removeCall: call;
- activeCall;
@end

@interface NXPhoneChannel (RemoteCallBackMethods)

- allocateIncomingCallOfType:(NXPhoneCallType)t;
- (BOOL)acceptCall: newCall;
- (void)channelError: (NXPhoneError)reason;

@end
