/*
 * ISDN/POTS Project
 * Copyright 1991, 1992 NeXT, Inc.
 *
 * phoneType.h 
 *
 * Types for PhoneKit objects
 */


/*
 *  Constants used to indicate device type.  These are passed
 *  to initDevice: to initialize the device type.
 */
typedef enum {
	NX_ISDNDevice=1,
	NX_POTSDevice=2
} NXPhoneDeviceType;


/*
 *  Definitions for various channels and types.
 */
typedef enum {
	NX_B1Channel,
	NX_B2Channel,
	NX_DChannel,
	NX_POTSChannel,
	NX_AnyISDNChannel,
} NXPhoneChannelType;

typedef enum {
	NX_DataCall 		= 4,
	NX_VoiceCall 		= 5,
} NXPhoneCallType;

typedef enum {
	NX_PhoneNullState 	= -1,
	NX_PhoneIdle 		= 0,
	NX_PhoneOriginating 	= 1,
	NX_PhoneDialing 	= 2,
	NX_PhoneConversation 	= 3,
	NX_PhoneAlerting 	= 4,
	NX_PhoneReleasing 	= 5,
} NXPhoneCallState;
