/*
IXStoreFile.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	"IXStore.h"

@interface IXStoreFile: IXStore
{
    int			descriptor;
    const char		*filename;
    struct		{
	unsigned	needsClose:1;
	unsigned	isCreating:1;
    }			fileStatus;
}

- free; // releases lock and closes file descriptor
- init; // creates a temporary file

- (int)descriptor; // descriptor is closed on free
- (const char *)filename;

- initWithFile:(const char *)filename; // for w&ng; creates if necessary
- initFromFile:(const char *)filename // returns nil if file does not exist
    forWriting:(BOOL)writingFlag;

- setSizeLimit:(vm_size_t)limit; // sets resident size limit; zero unlimits
- (vm_size_t)sizeLimit; // returns current size limit, or zero if no limit

@end

